package io.zipcoder;

import java.util.Stack;

public class ParenChecker {

    public static boolean parenChecker(String input) {
        if (input.charAt(0) == ')')
            return false;

        Stack<Character> stack = new Stack<Character>();

        char c;
        for(int i=0; i < input.length(); i++) {
            c = input.charAt(i);

            if(c == '(')
                stack.push(c);
            else if(c == ')')
                if(stack.empty())
                    return false;
                else if(stack.peek() == ')')
                    return false;
                else
                    stack.pop();
        }
        return stack.empty();

    }

    public static boolean symbolChecker(String input, char symbol) {
        if (input.charAt(0) == ')' | input.charAt(0) == '}' | input.charAt(0) == ']' | input.charAt(0) == '>')
            return false;

        char symbol2;

        switch (symbol) {
            case '(': return parenChecker(input);
            case '{': symbol2 = '}'; break;
            case '[': symbol2 = ']'; break;
            case '<': symbol2 = '>'; break;
            case '"': symbol2 = symbol; break;
            case '\'': symbol2 = symbol; break;
            default: return false;
        }

        Stack<Character> stack = new Stack<Character>();

        int count = 0;
        if(symbol == symbol2) {
            for(int i = 0; i < input.length(); i++) {
                if(input.charAt(i) == symbol) count++;
            }
            if(count % 2 == 0) {
                return true;
            } else {
                return false;
            }
        }

        char c;
        for(int i=0; i < input.length(); i++) {
            c = input.charAt(i);

            if(c == symbol)
                stack.push(c);
            else if(c == symbol2)
                if(stack.empty())
                    return false;
                else if(stack.peek() == symbol2)
                    return false;
                else
                    stack.pop();
        }
        return stack.empty();

    }

    public static boolean checkAllSymbols (String input) {
        boolean result = symbolChecker(input, '{');
            if(result == false) {
                return false;
            }
        result = symbolChecker(input, '[');
        if(result == false) {
            return false;
        }
        result = symbolChecker(input, '<');
        if(result == false) {
            return false;
        }
        result = symbolChecker(input, '\"');
        if(result == false) {
            return false;
        }
        result = symbolChecker(input, '\'');
        if(result == false) {
            return false;
        }
        result = parenChecker(input);
        if(result == false) {
            return false;
        }
        return true;
    }


}