package io.zipcoder;

import org.junit.Assert;
import org.junit.Test;

public class ParenCheckerTest {

    @Test
    public void testParenChecker() {
        //Given
        String test1 = "()";
        boolean expected = true;

        //When
        boolean actual = ParenChecker.parenChecker(test1);

        //Then
        Assert.assertEquals(expected, actual);


    }

    @Test
    public void testParenChecker2() {
        //Given
        String test1 = "()()()()";
        boolean expected = true;

        //When
        boolean actual = ParenChecker.parenChecker(test1);

        //Then
        Assert.assertEquals(expected, actual);


    }

    @Test
    public void testParenChecker3() {
        //Given
        String test1 = "()(())()";
        boolean expected = true;

        //When
        boolean actual = ParenChecker.parenChecker(test1);

        //Then
        Assert.assertEquals(expected, actual);


    }

    @Test
    public void testParenChecker4() {
        //Given
        String test1 = "()))";
        boolean expected = false;

        //When
        boolean actual = ParenChecker.parenChecker(test1);

        //Then
        Assert.assertEquals(expected, actual);


    }

    @Test
    public void testParenChecker5() {
        //Given
        String test1 = ")(((((((((((()";
        boolean expected = false;

        //When
        boolean actual = ParenChecker.parenChecker(test1);

        //Then
        Assert.assertEquals(expected, actual);


    }

    @Test
    public void testParenChecker6() {
        //Given
        String test1 = "(abc)";
        boolean expected = true;

        //When
        boolean actual = ParenChecker.parenChecker(test1);

        //Then
        Assert.assertEquals(expected, actual);


    }

    @Test
    public void testParenChecker7() {
        //Given
        String test1 = "()(yup(hi))";
        boolean expected = true;

        //When
        boolean actual = ParenChecker.parenChecker(test1);

        //Then
        Assert.assertEquals(expected, actual);


    }

    @Test
    public void testParenChecker8() {
        //Given
        String test1 = "()huh))gh(";
        boolean expected = false;

        //When
        boolean actual = ParenChecker.parenChecker(test1);

        //Then
        Assert.assertEquals(expected, actual);


    }

    @Test
    public void testSymbolChecker1() {
        //Given
        String test1 = "{}";
        boolean expected = true;

        //When
        boolean actual = ParenChecker.symbolChecker(test1, '{');

        //Then
        Assert.assertEquals(expected, actual);


    }

    @Test
    public void testSymbolChecker2() {
        //Given
        String test1 = "{}}}{";
        boolean expected = false;

        //When
        boolean actual = ParenChecker.symbolChecker(test1, '{');

        //Then
        Assert.assertEquals(expected, actual);


    }


    @Test
    public void testSymbolChecker3() {
        //Given
        String test1 = "\"\"";
        boolean expected = true;

        //When
        boolean actual = ParenChecker.symbolChecker(test1, '\"');

        //Then
        Assert.assertEquals(expected, actual);


    }

    @Test
    public void testSymbolChecker4() {
        //Given
        String test1 = "huh\"\"\"s";
        boolean expected = false;

        //When
        boolean actual = ParenChecker.symbolChecker(test1, '\"');

        //Then
        Assert.assertEquals(expected, actual);


    }

    @Test
    public void testSymbolChecker5() {
        //Given
        String test1 = "\'";
        boolean expected = false;

        //When
        boolean actual = ParenChecker.symbolChecker(test1, '\'');

        //Then
        Assert.assertEquals(expected, actual);


    }

    @Test
    public void testSymbolChecker6() {
        //Given
        String test1 = "\'{()FFDG\'k&";
        boolean expected = true;

        //When
        boolean actual = ParenChecker.symbolChecker(test1, '\'');

        //Then
        Assert.assertEquals(expected, actual);


    }

    @Test
    public void testSymbolChecker7() {
        //Given
        String test1 = "\'{()FF(DG\'k&";
        boolean expected = false;

        //When
        boolean actual = ParenChecker.symbolChecker(test1, '(');

        //Then
        Assert.assertEquals(expected, actual);


    }

    @Test
    public void testSymbolChecker8() {
        //Given
        String test1 = "[]]";
        boolean expected = false;

        //When
        boolean actual = ParenChecker.symbolChecker(test1, '[');

        //Then
        Assert.assertEquals(expected, actual);


    }

    @Test
    public void testSymbolChecker9() {
        //Given
        String test1 = "[][[]]";
        boolean expected = true;

        //When
        boolean actual = ParenChecker.symbolChecker(test1, '[');

        //Then
        Assert.assertEquals(expected, actual);


    }

    @Test
    public void testSymbolChecker10() {
        //Given
        String test1 = "<<hi>>";
        boolean expected = true;

        //When
        boolean actual = ParenChecker.symbolChecker(test1, '<');

        //Then
        Assert.assertEquals(expected, actual);


    }

    @Test
    public void testSymbolChecker11() {
        //Given
        String test1 = "<<i>><)";
        boolean expected = false;

        //When
        boolean actual = ParenChecker.symbolChecker(test1, '<');

        //Then
        Assert.assertEquals(expected, actual);


    }


    @Test
    public void testSymbolChecker12() {
        //Given
        String test1 = ">>>>";
        boolean expected = false;

        //When
        boolean actual = ParenChecker.symbolChecker(test1, '<');

        //Then
        Assert.assertEquals(expected, actual);


    }

    @Test
    public void testSymbolChecker13() {
        //Given
        String test1 = "<<i>><)";
        boolean expected = false;

        //When
        boolean actual = ParenChecker.symbolChecker(test1, '?');

        //Then
        Assert.assertEquals(expected, actual);


    }

    @Test
    public void testSymbolChecker14() {
        //Given
        String test1 = "55>>>>>>";
        boolean expected = false;

        //When
        boolean actual = ParenChecker.symbolChecker(test1, '<');

        //Then
        Assert.assertEquals(expected, actual);


    }

    @Test
    public void testCheckAllSymbols() {
        //Given
        String test1 = "({(}<>))";
        boolean expected = true;

        //When
        boolean actual = ParenChecker.checkAllSymbols(test1);

        //Then
        Assert.assertEquals(expected, actual);


    }

    @Test
    public void testCheckAllSymbols2() {
        //Given
        String test1 = "<{pf>()\"\"";
        boolean expected = false;

        //When
        boolean actual = ParenChecker.checkAllSymbols(test1);

        //Then
        Assert.assertEquals(expected, actual);


    }

    @Test
    public void testCheckAllSymbols3() {
        //Given
        String test1 = "<{pf>()\"\"}\'";
        boolean expected = false;

        //When
        boolean actual = ParenChecker.checkAllSymbols(test1);

        //Then
        Assert.assertEquals(expected, actual);


    }

    @Test
    public void testCheckAllSymbols4() {
        //Given
        String test1 = "<{pf()\"\"}\'";
        boolean expected = false;

        //When
        boolean actual = ParenChecker.checkAllSymbols(test1);

        //Then
        Assert.assertEquals(expected, actual);


    }

    @Test
    public void testCheckAllSymbols5() {
        //Given
        String test1 = "<{pf)\">\"}";
        boolean expected = false;

        //When
        boolean actual = ParenChecker.checkAllSymbols(test1);

        //Then
        Assert.assertEquals(expected, actual);


    }

}