package io.zipcoder;

import org.junit.Assert;
import org.junit.Test;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.LinkedHashMap;

public class WCTest {

    @Test
    public void testCountTheWords() {
        //Given
        String fileName = "./../../someTextFile.txt";
        String fullPath = WC.class.getResource(fileName).getFile();
        WC wc = new WC(fullPath);
        Integer expected = 3;

        //When
        HashMap<String, Integer> result = wc.readFile();
        Integer actual = result.get("cow");

        //Then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void testSortedList() {
        //Given
        String fileName = "./../../someTextFile.txt";
        String fullPath = WC.class.getResource(fileName).getFile();
        WC wc = new WC(fullPath);
        Integer expected = 3;

        //When
        HashMap<String, Integer> result = wc.readFile();
        LinkedHashMap<String, Integer> sort = WC.sortList(result);
        Integer actual = result.get("cow");

        //Then
        Assert.assertEquals(expected, actual);
    }

}